/***************************************************************************
**
**  Copyright (C) 2002-2009 Marc Wathelet. All rights reserved.
**
**  This file is part of qtbtools.
**
**  This library is free software; you can redistribute it and/or
**  modify it under the terms of the GNU Lesser General Public
**  License as published by the Free Software Foundation; either
**  version 2.1 of the License, or (at your option) any later version.
**
**  This file is distributed in the hope that it will be useful, but WITHOUT
**  ANY WARRANTY; without even the implied warranty of MERCHANTABILITY or
**  FITNESS FOR A PARTICULAR PURPOSE. See the GNU Lesser General Public
**  License for more details.
**
**  You should have received a copy of the GNU Lesser General Public
**  License along with this library; if not, write to the Free Software
**  Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston, MA  02110-1301  USA
**
**  See http://www.geopsy.org for more information.
**
**  Created : 2007-11-12
**
***************************************************************************/

#include "qtbabstractfunction2.h"

/*!
  \class QtbAbstractFunction2 qtbabstractfunction2.h
  \brief Abstract 2D function

  This function is used by QtbGridSearch, QtbConcentricSearch and QtbDirectionalSearch. Values are required for
  gridded (x,y) couples and for free couples. For gridded couples, computation of values can be cached.
*/

/*!
  \fn QtbAbstractFunction2()
  Default constructor
*/

/*!
  \fn virtual ~QtbAbstractFunction2()
  Default destructor
*/

/*!
  \fn double QtbAbstractFunction2::value(double x, double y) const
  Implemement this function to calculate the 2D function at \a x and \a y.
*/

/*!
  \fn double QtbAbstractFunction2::value(double x, double y, int index) const
  Re-mplemement this function to calculate the 2D function for \a x and \a y aligned to a grid.
  \a x and \a y correspond to \a index in the grid: \a index = iy * nx + ix

  If nothing is cached re-implementation of this function is useless.
*/

/*!
  \fn void QtbAbstractFunction2::initGrid(int n)
  Re-implemement if the computation of value(double x, double y) requires caching for gridded couples (x,y).
  \a n is the total number of grid points: nx*ny
*/

/*!
  \fn void QtbAbstractFunction2::initGrid(double x, double y, int index)
  Re-implemement if the computation of value(double x, double y) requires caching for gridded couples (x,y).
  This fonction initialize the cached values for \a x and \a y aligned to a grid and corresponding to \a index.
*/
