/***************************************************************************
**
**  Copyright (C) 2002-2009 Marc Wathelet. All rights reserved.
**
**  This file is part of qtbtools.
**
**  This library is free software; you can redistribute it and/or
**  modify it under the terms of the GNU Lesser General Public
**  License as published by the Free Software Foundation; either
**  version 2.1 of the License, or (at your option) any later version.
**
**  This file is distributed in the hope that it will be useful, but WITHOUT
**  ANY WARRANTY; without even the implied warranty of MERCHANTABILITY or
**  FITNESS FOR A PARTICULAR PURPOSE. See the GNU Lesser General Public
**  License for more details.
**
**  You should have received a copy of the GNU Lesser General Public
**  License along with this library; if not, write to the Free Software
**  Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston, MA  02110-1301  USA
**
**  See http://www.geopsy.org for more information.
**
**  Created : 2007-11-12
**
***************************************************************************/

#ifndef QTB_ABSTRACTFUNCTION2_H
#define QTB_ABSTRACTFUNCTION2_H

#include <qglobal.h>

#include "qtbtoolsdllexport.h"

class QTBTOOLS_EXPORT QtbAbstractFunction2
{
public:
  QtbAbstractFunction2() {}
  virtual ~QtbAbstractFunction2() {}

  virtual double value(double x, double y) const=0;
  virtual double value(double x, double y, int index) const { Q_UNUSED(index); return value(x, y); }
  virtual void initGrid(int n) { Q_UNUSED(n); }
  virtual void initGrid(double x, double y, int index) { Q_UNUSED(x); Q_UNUSED(y); Q_UNUSED(index); }
};

#endif // QTB_ABSTRACTFUNCTION2_H
