/***************************************************************************
**
**  Copyright (C) 2002-2009 Marc Wathelet. All rights reserved.
**
**  This file is part of qtbtools.
**
**  This library is free software; you can redistribute it and/or
**  modify it under the terms of the GNU Lesser General Public
**  License as published by the Free Software Foundation; either
**  version 2.1 of the License, or (at your option) any later version.
**
**  This file is distributed in the hope that it will be useful, but WITHOUT
**  ANY WARRANTY; without even the implied warranty of MERCHANTABILITY or
**  FITNESS FOR A PARTICULAR PURPOSE. See the GNU Lesser General Public
**  License for more details.
**
**  You should have received a copy of the GNU Lesser General Public
**  License along with this library; if not, write to the Free Software
**  Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston, MA  02110-1301  USA
**
**  See http://www.geopsy.org for more information.
**
**  Created : 2004-10-07
**
***************************************************************************/

#include <math.h>

#include "qtbangle.h"
#include "qtbmemorychecker.h"

/*!
  \fn QtbAngle::QtbAngle()
  Init a 0 radian angle
*/

/*!
  \fn void QtbAngle::set(double dx, double dy)
  Set cosine and sine with compution of distance (sqrt(dx*dx+dy*dy))
*/

/*!
  \fn void QtbAngle::set(double dx, double dy, double r)
  Set cosine and sine without recompution of distance (sqrt(dx*dx+dy*dy))
*/

/*!
  \fn QtbAngle& QtbAngle::operator=(const QtbAngle& o)
*/

/*!
  \fn void QtbAngle::initDegrees()
  From angle in radians, compute angle in degrees
*/

/*!
  \fn void QtbAngle::initRadians()
  From cosine and sine of angle, compute angle in radians from -pi/2 to pi/2
*/

/*!
  \fn void QtbAngle::setDegrees(double degrees)
  Can access angle in degrees, radians, sine or cosine.
*/

/*!
  \fn void QtbAngle::setRadians(double radians)
  Degrees are not set, only angle in radians, sine or cosine.
  To be able to call degrees(), call initDegrees() before.
*/

/*!
  \fn void QtbAngle::chSign()
  Reverse angle sign.
*/

/*!
  \fn void QtbAngle::mirror()
  Rotate angle by 180 degrees
*/
