/***************************************************************************
**
**  Copyright (C) 2002-2009 Marc Wathelet. All rights reserved.
**
**  This file is part of qtbtools.
**
**  This library is free software; you can redistribute it and/or
**  modify it under the terms of the GNU Lesser General Public
**  License as published by the Free Software Foundation; either
**  version 2.1 of the License, or (at your option) any later version.
**
**  This file is distributed in the hope that it will be useful, but WITHOUT
**  ANY WARRANTY; without even the implied warranty of MERCHANTABILITY or
**  FITNESS FOR A PARTICULAR PURPOSE. See the GNU Lesser General Public
**  License for more details.
**
**  You should have received a copy of the GNU Lesser General Public
**  License along with this library; if not, write to the Free Software
**  Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston, MA  02110-1301  USA
**
**  See http://www.geopsy.org for more information.
**
**  Created : 2008-12-11
**
***************************************************************************/

#include "qtbargumentstdinreader.h"
#include "qtbcoreapplication.h"
#include "qtbtrace.h"
#include "qtbmemorychecker.h"

/*!
  \class QtbArgumentStdinReader qtbargumentstdinreader.h
  \brief Brief description of class still missing

  Full description of class still missing
*/

/*!
  Reads all files listed in arguments \a argc and \a argv.
  If there is no arguments, the stdin is read.
  If an error occurs, it returns false.
*/
bool QtbArgumentStdinReader::read(int argc, char ** argv)
{
  QTB_TRACE;
  QTextStream sIn;
  int i = 1;
  QFile * f;
  if (i==argc) {
    f = new QFile;
    f->open(stdin,QIODevice::ReadOnly);
    sIn.setDevice( f );
  } else {
    f = 0;
  }
  while (true) {
    if (f && sIn.atEnd()) {
      delete f;
      f=0;
    }
    if (!f) {
      if (i<argc) {
        f = new QFile(argv[i]);
        if (!f->open(QIODevice::ReadOnly)) {
          qtbApp << tr("Cannot open file %1 for reading.").arg(argv[i]) << endl;
          return false;
        }
        sIn.setDevice( f );
        i++;
      } else return true;
    }
    if ( !parse(sIn) ) {
      return true;
    }
  }
  return false;
}
