/***************************************************************************
**
**  Copyright (C) 2002-2009 Marc Wathelet. All rights reserved.
**
**  This file is part of qtbtools.
**
**  This library is free software; you can redistribute it and/or
**  modify it under the terms of the GNU Lesser General Public
**  License as published by the Free Software Foundation; either
**  version 2.1 of the License, or (at your option) any later version.
**
**  This file is distributed in the hope that it will be useful, but WITHOUT
**  ANY WARRANTY; without even the implied warranty of MERCHANTABILITY or
**  FITNESS FOR A PARTICULAR PURPOSE. See the GNU Lesser General Public
**  License for more details.
**
**  You should have received a copy of the GNU Lesser General Public
**  License along with this library; if not, write to the Free Software
**  Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston, MA  02110-1301  USA
**
**  See http://www.geopsy.org for more information.
**
**  Created : 2006-07-06
**
***************************************************************************/

#include "qtbcacheitem.h"

/*!
  \class QtbCacheItem qtbcacheitem.h
  \brief Brief description of class still missing

  Full description of class still missing
*/

/*!
  \fn QtbCacheItem::QtbCacheItem()
  Description of constructor still missing
*/

/*!
  \fn QtbCacheItem::QtbCacheItem( const QtbCacheItem& o )
  Description of copy constructor still missing
*/

/*!
  \fn QtbCacheItem::~QtbCacheItem()
  Assert if still locked or saved
*/

/*!
  \fn QtbCacheItem::lock()
  lock() and unlock() are necessary to control allocation/deallocation of item data in cache. When
  an item is locked the cache manager cannot deallocate the item data. unlock() leave the item data in the cache
  and the data will be deallocated if requested by new allocations.

  This class is not thread safe. You must call lock() and unlock() in a thread safe class with QMutex

  \sa unlock()
*/

/*!
  \fn QtbCacheItem::unlock()
  lock() and unlock() are necessary to control allocation/deallocation of item data in cache. When
  an item is locked the cache manager cannot deallocate the item data. unlock() leave the item data in the cache
  and the data will be deallocated if requested by new allocations.

  This class is not thread safe. You must call lock() and unlock() in a thread safe class with QMutex

  \sa lock()
*/

/*!
  \fn QtbCacheItem::touch()

  This class is not thread safe. You must call touch() in a thread safe class with QMutex
*/

/*!
  Set priority to \a priority. If priority was 0, priority is set to \a priority. If not, priorities are multiplied.
*/
void QtbCacheItem::setPriority( int /*priority*/ ) const
{
  /*QMutexLocker ml(&_priorityMutex);
  // In normal situation, you cannot change priority of a saved priority
  QTB_ASSERT(!_priorityReadOnly);
  if (_priority>0)
    _priority *= priority;
  else
    _priority = priority;*/
}

/*!
  Set priority to the same priority as \a item. Mainly used when several signals are required at the same time to
  avoid useless deletion from cache. The allocation priority is locked (for other threads) until calling
  restoreAllocationPriority( int priority ).

  \sa restoreAllocationPriority( int priority )
*/
int QtbCacheItem::savePriority( const QtbCacheItem * /*item*/ ) const
{
  /*QMutexLocker ml(&_priorityMutex);
  int tmp = _priority;
  _priority = item->_priority;
  _priorityReadOnly = true;
  return tmp;*/
  return 0;
}

/*!
  Restore priority and unlock priority changes.

  \sa savePriority( QtbCacheItem * item )
*/
void QtbCacheItem::restorePriority( int /*priority*/ ) const
{
  /*QMutexLocker ml(&_priorityMutex);
  _priorityReadOnly = false;
  _priority = priority;*/
}

int QtbCacheItem::priority() const
{
  /*QMutexLocker ml(&_priorityMutex);
  return _priority;*/
  return 0;
}

/*!
  \fn bool QtbCacheItem::isAllocated()
  Implement this function to return true is data is allocated.
*/

/*!
  \fn int QtbCacheItem::dataSize()
  Implement this function to return the size of the data to allocate.
*/

/*!
  \fn bool QtbCacheItem::allocate()
  Implement this function to allocate the data. Return true if successful.
*/

/*!
  \fn void QtbCacheItem::free()
  Implement this function to free the data. Never call this function directly, use QtbCache::free() instead.
*/

/*!
  \fn void QtbCacheItem::save( QDir& d )
  Implement this function to save the data to disk when memory usage requires it.
*/

/*!
  \fn void QtbCacheItem::load( QDir& d )
  Implement this function to load the data from disk upon request.
  \sa load()
*/
