/***************************************************************************
**
**  Copyright (C) 2002-2009 Marc Wathelet. All rights reserved.
**
**  This file is part of qtbtools.
**
**  This library is free software; you can redistribute it and/or
**  modify it under the terms of the GNU Lesser General Public
**  License as published by the Free Software Foundation; either
**  version 2.1 of the License, or (at your option) any later version.
**
**  This file is distributed in the hope that it will be useful, but WITHOUT
**  ANY WARRANTY; without even the implied warranty of MERCHANTABILITY or
**  FITNESS FOR A PARTICULAR PURPOSE. See the GNU Lesser General Public
**  License for more details.
**
**  You should have received a copy of the GNU Lesser General Public
**  License along with this library; if not, write to the Free Software
**  Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston, MA  02110-1301  USA
**
**  See http://www.geopsy.org for more information.
**
**  Created : 2003-05-12
**
***************************************************************************/

#ifndef QTB_Circle_H
#define QTB_Circle_H

#include <QVector>

#include "qtbpoint2d.h"

class QTBTOOLS_EXPORT QtbCircle
{
public:
  QtbCircle(double x0,double y0, double r);
  virtual ~QtbCircle() {}

  QVector<QtbPoint2D> intersect( const QtbCircle& o );
  QtbPoint2D intersect( const QtbCircle& o, bool& ok, const QtbCircle& disc );
  double distanceTo( const QtbPoint2D& p ) const;
private:
  double _x0,_y0,_r;
};

#endif
