/***************************************************************************
**
**  Copyright (C) 2002-2009 Marc Wathelet. All rights reserved.
**
**  This file is part of qtbtools.
**
**  This library is free software; you can redistribute it and/or
**  modify it under the terms of the GNU Lesser General Public
**  License as published by the Free Software Foundation; either
**  version 2.1 of the License, or (at your option) any later version.
**
**  This file is distributed in the hope that it will be useful, but WITHOUT
**  ANY WARRANTY; without even the implied warranty of MERCHANTABILITY or
**  FITNESS FOR A PARTICULAR PURPOSE. See the GNU Lesser General Public
**  License for more details.
**
**  You should have received a copy of the GNU Lesser General Public
**  License along with this library; if not, write to the Free Software
**  Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston, MA  02110-1301  USA
**
**  See http://www.geopsy.org for more information.
**
**  Created : 2008-11-01
**
***************************************************************************/

#include "qtbcolumntextdescription.h"
#include "qtbmemorychecker.h"

/*!
  \class QtbColumnTextDescription qtbcolumntextdescription.h
  \brief Storage for the decription of column in a QtbColumnTextParser

  Full description of class still missing
*/

const QString QtbColumnTextDescription::xmlColumnTextDescriptionTag = "ColumnTextDescription";

void QtbColumnTextDescription::xml_writeProperties(XML_WRITEPROPERTIES_ARGS) const
{
  QTB_TRACE;
  Q_UNUSED(context);
  writeProperty( s, "type", _type );
  writeProperty( s, "factor", _factor );
  writeProperty( s, "replaceRx", _replaceRx );
  writeProperty( s, "replaceAfter", _replaceAfter );
}

QtbXMLMember QtbColumnTextDescription::xml_member(XML_MEMBER_ARGS)
{
  QTB_TRACE;
  Q_UNUSED(attributes);
  Q_UNUSED(context);
  if ( tag == "type" ) return QtbXMLMember( 0 );
  else if ( tag == "factor" ) return QtbXMLMember( 1 );
  else if ( tag == "replaceRx" ) return QtbXMLMember( 2 );
  else if ( tag == "replaceAfter" ) return QtbXMLMember( 3 );
  return QtbXMLMember(QtbXMLMember::Unknown);
}

bool QtbColumnTextDescription::xml_setProperty(XML_SETPROPERTY_ARGS)
{
  QTB_TRACE;
  Q_UNUSED(attributes);
  Q_UNUSED(context);
  switch ( memberID ) {
  case 0: _type = content.toInt(); return true;
  case 1: _factor = content.toDouble(); return true;
  case 2: _replaceRx = content.toString(); return true;
  case 3: _replaceAfter = content.toString(); return true;
  default: return false;
  }
}
