/***************************************************************************
**
**  Copyright (C) 2002-2009 Marc Wathelet. All rights reserved.
**
**  This file is part of qtbtools.
**
**  This library is free software; you can redistribute it and/or
**  modify it under the terms of the GNU Lesser General Public
**  License as published by the Free Software Foundation; either
**  version 2.1 of the License, or (at your option) any later version.
**
**  This file is distributed in the hope that it will be useful, but WITHOUT
**  ANY WARRANTY; without even the implied warranty of MERCHANTABILITY or
**  FITNESS FOR A PARTICULAR PURPOSE. See the GNU Lesser General Public
**  License for more details.
**
**  You should have received a copy of the GNU Lesser General Public
**  License along with this library; if not, write to the Free Software
**  Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston, MA  02110-1301  USA
**
**  See http://www.geopsy.org for more information.
**
**  Created : 2007-02-08
**
***************************************************************************/

#include <QLocale>

#include "qtbcoreapplication.h"

/*!
  \class QtbCoreApplication qtbcoreapplication.h
  \brief Brief description of class still missing

  Full description of class still missing
*/

/*!
  Description of constructor still missing
*/
QtbCoreApplication::QtbCoreApplication( int & argc, char ** argv, QtbApplicationHelp * ( *help ) (), bool reportBugs  )
    : QtbCoreApplicationPrivate(argc, argv), QCoreApplication(argc, argv)
{
  // Qt application information
  setApplicationName( QtbCoreApplicationPrivate::constructorApplicationName() );
  setOrganizationDomain( "geopsy.org" );
  setOrganizationName( "geopsy" );
  // Install message handler
  setMessageHandler( new QtbMessage );
  // load translation if necessary
  initTranslations();

  // Check arguments
  int i, j = 1;
  for (i=1; i<argc; i++) {
    QByteArray arg = argv[i];
    if (arg=="-reportbug" || arg=="-reportint") {
      reportBug();
      ::exit(0);
    } else if (help && (arg=="--help" || arg=="-help" || arg=="-h")) {
      showHelp( i, argc, argv, help );
      ::exit(0);
    } else if (arg=="--nobugreport" || arg=="-nobugreport") {
      reportBugs = false;
    } else {
      argv[j++] = argv[i];
    }
  }
  if(j < argc) {
    argv[j] = 0;
    argc = j;
  }

  initInternalDebugger(reportBugs);
  checkAtomicOperations();

  // Use current system locale (interesting for decimal point conversions)
  QLocale::setDefault( QLocale::system() );
}

/*!
  Description of destructor still missing
*/
QtbCoreApplication::~QtbCoreApplication()
{
  destructorCleanUp();
}

/*!
  
*/
void QtbCoreApplication::reportBug()
{
  qtbApp << tr("\nPlease copy the message below to http://www.geopsy.org/bugs/backtrace.php:\n") << endl;
  qtbApp << getStdin() << endl;
  qtbApp << tr("Please copy the above message to http://www.geopsy.org/bugs/backtrace.php.\n"
               "Only the XML content must be copied: <CrashReport>...</CrashReport>\n"
               "This is the system information to copy in the first field of this online form.") << endl;
}

/*!
  
*/
void QtbCoreApplication::setHelp( QtbApplicationHelp * h )
{
  h->addGroup(tr("Generic"), "generic");
  QtbCoreApplicationPrivate::setHelp(h);
}
