/***************************************************************************
**
**  Copyright (C) 2002-2009 Marc Wathelet. All rights reserved.
**
**  This file is part of qtbtools.
**
**  This library is free software; you can redistribute it and/or
**  modify it under the terms of the GNU Lesser General Public
**  License as published by the Free Software Foundation; either
**  version 2.1 of the License, or (at your option) any later version.
**
**  This file is distributed in the hope that it will be useful, but WITHOUT
**  ANY WARRANTY; without even the implied warranty of MERCHANTABILITY or
**  FITNESS FOR A PARTICULAR PURPOSE. See the GNU Lesser General Public
**  License for more details.
**
**  You should have received a copy of the GNU Lesser General Public
**  License along with this library; if not, write to the Free Software
**  Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston, MA  02110-1301  USA
**
**  See http://www.geopsy.org for more information.
**
**  Created : 2009-07-22
**
***************************************************************************/

#include "qtbdynamicbuffer.h"
#include "qtbtrace.h"
#include "qtbmemorychecker.h"

/*!
  \class QtbDynamicBuffer qtbdynamicbuffer.h
  \brief Brief description of class still missing

  Full description of class still missing
*/

/*!
  Description of constructor still missing
*/
QtbDynamicBuffer::QtbDynamicBuffer()
{
  QTB_TRACE;
  _bufferCapacity=64;
  _buffer=(char *)malloc(_bufferCapacity);
  _bufferIn=0;
  _bufferOut=0;
}

/*!
  Description of destructor still missing
*/
QtbDynamicBuffer::~QtbDynamicBuffer()
{
  QTB_TRACE;
  free(_buffer);
}

void QtbDynamicBuffer::clear()
{
  QTB_TRACE;
  if(_bufferCapacity>64) {
    free(_buffer);
    _bufferCapacity=64;
    _buffer=(char *)malloc(_bufferCapacity);
  }
  _bufferIn=0;
  _bufferOut=0;
}

void QtbDynamicBuffer::add(const char * data, int byteCount)
{
  QTB_TRACE;
  //printf("before %i %i %i - add %i\n",_bufferOut, _bufferIn, _bufferCapacity, byteCount);
  int nextBufferIn=_bufferIn+byteCount;
  int neededBytes=nextBufferIn-_bufferCapacity;
  if(neededBytes>0) {
    if (_bufferOut<neededBytes) {
      _bufferCapacity=_bufferCapacity << 1;
      _buffer=(char *)realloc(_buffer, _bufferCapacity);
    } else {
      if(_bufferIn>_bufferOut) {
        memmove(_buffer,_buffer+_bufferOut, _bufferIn-_bufferOut);
        _bufferIn-=_bufferOut;
        nextBufferIn-=_bufferOut;
      } else {
        _bufferIn=0;
        nextBufferIn=byteCount;
      }
      _bufferOut=0;
    }
  }
  memcpy(_buffer+_bufferIn, data, byteCount);
  _bufferIn=nextBufferIn;
  //printf("after %i %i %i\n",_bufferOut, _bufferIn, _bufferCapacity);
  /*for(int i=0;i<32;i++) {
    printf("%02hhX ",_buffer[_bufferOut+i]);
  }
  printf("\n");*/
}
