/***************************************************************************
**
**  Copyright (C) 2002-2009 Marc Wathelet. All rights reserved.
**
**  This file is part of qtbtools.
**
**  This library is free software; you can redistribute it and/or
**  modify it under the terms of the GNU Lesser General Public
**  License as published by the Free Software Foundation; either
**  version 2.1 of the License, or (at your option) any later version.
**
**  This file is distributed in the hope that it will be useful, but WITHOUT
**  ANY WARRANTY; without even the implied warranty of MERCHANTABILITY or
**  FITNESS FOR A PARTICULAR PURPOSE. See the GNU Lesser General Public
**  License for more details.
**
**  You should have received a copy of the GNU Lesser General Public
**  License along with this library; if not, write to the Free Software
**  Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston, MA  02110-1301  USA
**
**  See http://www.geopsy.org for more information.
**
**  Created : 2009-07-22
**
***************************************************************************/

#ifndef QTB_DYNAMICBUFFER_H
#define QTB_DYNAMICBUFFER_H

#include "qtbtoolsdllexport.h"

class QTBTOOLS_EXPORT QtbDynamicBuffer
{
public:
  QtbDynamicBuffer();
  ~QtbDynamicBuffer();

  void add(const char * data, int byteCount);

  int availableBytes() const {return _bufferIn-_bufferOut;}
  const char * data() {return _buffer+_bufferOut;}
  void release(int byteCount) {_bufferOut+=byteCount;}
  void clear();
private:
  int _bufferCapacity;
  int _bufferIn;
  int _bufferOut;
  char * _buffer;
};

#endif // QTB_DYNAMICBUFFER_H
