/***************************************************************************
**
**  Copyright (C) 2002-2009 Marc Wathelet. All rights reserved.
**
**  This file is part of qtbtools.
**
**  This library is free software; you can redistribute it and/or
**  modify it under the terms of the GNU Lesser General Public
**  License as published by the Free Software Foundation; either
**  version 2.1 of the License, or (at your option) any later version.
**
**  This file is distributed in the hope that it will be useful, but WITHOUT
**  ANY WARRANTY; without even the implied warranty of MERCHANTABILITY or
**  FITNESS FOR A PARTICULAR PURPOSE. See the GNU Lesser General Public
**  License for more details.
**
**  You should have received a copy of the GNU Lesser General Public
**  License along with this library; if not, write to the Free Software
**  Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston, MA  02110-1301  USA
**
**  See http://www.geopsy.org for more information.
**
**  Created : 2007-04-10
**
***************************************************************************/

#ifndef QTB_EXPRESSIONPARSER_H
#define QTB_EXPRESSIONPARSER_H

#include <QString>
#include <QList>

#include "qtbtoolsdllexport.h"
#include "qtbexpressionactions.h"
#include "qtbexpressionaction.h"
#include "qtbtranslations.h"

class QTBTOOLS_EXPORT QtbExpressionParser
{
  QTB_TRANSLATIONS( "QtbExpressionParser" );
public:
  QtbExpressionActions parse( QString code, QtbExpressionContext * context );
private:
  bool parse( QtbExpressionAction * parent, QtbExpressionContext * context );
  enum ArgumentType {NoArgument, Numeric, AlphaNumeric, String};
  bool skipArgument( ArgumentType& type );
  bool skipOperator( QtbExpressionAction::Type& type );
  bool skipString();
  void skipBlanks();
  void skipLineComment();
  void skipMultiLineComment();
  bool badCharacterError();
  QString bufferLocation();
private:
  const QChar * _ptr;
  int _row;
  const QChar * _beginRowPtr;
  QString _lastString;
};

#endif // QTB_EXPRESSIONPARSER_H
