/***************************************************************************
**
**  Copyright (C) 2002-2009 Marc Wathelet. All rights reserved.
**
**  This file is part of qtbtools.
**
**  This library is free software; you can redistribute it and/or
**  modify it under the terms of the GNU Lesser General Public
**  License as published by the Free Software Foundation; either
**  version 2.1 of the License, or (at your option) any later version.
**
**  This file is distributed in the hope that it will be useful, but WITHOUT
**  ANY WARRANTY; without even the implied warranty of MERCHANTABILITY or
**  FITNESS FOR A PARTICULAR PURPOSE. See the GNU Lesser General Public
**  License for more details.
**
**  You should have received a copy of the GNU Lesser General Public
**  License along with this library; if not, write to the Free Software
**  Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston, MA  02110-1301  USA
**
**  See http://www.geopsy.org for more information.
**
**  Created : 2007-04-10
**
***************************************************************************/

#ifndef QTB_EXPRESSIONSTORAGE_H
#define QTB_EXPRESSIONSTORAGE_H

#include <QVariant>
#include <QVector>

#include "qtbtoolsdllexport.h"

class QTBTOOLS_EXPORT QtbExpressionStorage
{
public:
  QtbExpressionStorage() {}
  virtual ~QtbExpressionStorage() {}

  virtual QVariant value(int index) const=0;
  virtual void setValue(int index, const QVariant& val)=0;
  virtual bool isReadOnly() const {return false;}
};

class QTBTOOLS_EXPORT QtbExpressionVariableStorage : public QtbExpressionStorage
{
public:
  virtual QVariant value(int index) const;
  virtual void setValue(int index, const QVariant& val);
private:
  QVector<QVariant> _values;
};

#endif // QTB_EXPRESSIONSTORAGE_H
