/***************************************************************************
**
**  Copyright (C) 2002-2009 Marc Wathelet. All rights reserved.
**
**  This file is part of qtbtools.
**
**  This library is free software; you can redistribute it and/or
**  modify it under the terms of the GNU Lesser General Public
**  License as published by the Free Software Foundation; either
**  version 2.1 of the License, or (at your option) any later version.
**
**  This file is distributed in the hope that it will be useful, but WITHOUT
**  ANY WARRANTY; without even the implied warranty of MERCHANTABILITY or
**  FITNESS FOR A PARTICULAR PURPOSE. See the GNU Lesser General Public
**  License for more details.
**
**  You should have received a copy of the GNU Lesser General Public
**  License along with this library; if not, write to the Free Software
**  Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston, MA  02110-1301  USA
**
**  See http://www.geopsy.org for more information.
**
**  Created : 2003-10-09
**
***************************************************************************/

#ifndef QTB_GETOPT_H
#define QTB_GETOPT_H

#include <qglobal.h>

#include "qtbtoolsdllexport.h"

/* On Mac OS X, when the application is started from the Finder
   the first argument is always -psn_0_xxxxxxx, so we just ignore
   all unrecognized argument. Add macro QTB_CHECKARGS at the beginning
   of your main().
*/
#ifdef Q_WS_MACX
#define QTB_CHECKARGS  if (argc>1 && strncmp(argv[1],"-psn_",5)==0) {argv++;argc--;}
#else
#define QTB_CHECKARGS
#endif // Q_WS_MACX

#ifdef Q_OS_LINUX
#include <getopt.h>
#else

enum Option_Type {ArgNotValid,ArgValue,ArgNoValue,ArgOptValue};
struct option {
  const char *name;
  int has_arg;
  int * flag;
  int val;
};
extern QTBTOOLS_EXPORT int optind;
extern QTBTOOLS_EXPORT char * optarg;
QTBTOOLS_EXPORT int getopt(int argc, char *argv[], const char * options);
QTBTOOLS_EXPORT int getopt_long(int argc, char *argv[], const char * options,
                                const struct option * longopts, int * longind);
QTBTOOLS_EXPORT int getopt_long_only(int argc, char *argv[], const char * options,
                                     const struct option * longopts, int * longind);
#endif // Q_OS_LINUX

#endif // QTB_GETOPT_H
