/***************************************************************************
**
**  Copyright (C) 2002-2009 Marc Wathelet. All rights reserved.
**
**  This file is part of qtbtools.
**
**  This library is free software; you can redistribute it and/or
**  modify it under the terms of the GNU Lesser General Public
**  License as published by the Free Software Foundation; either
**  version 2.1 of the License, or (at your option) any later version.
**
**  This file is distributed in the hope that it will be useful, but WITHOUT
**  ANY WARRANTY; without even the implied warranty of MERCHANTABILITY or
**  FITNESS FOR A PARTICULAR PURPOSE. See the GNU Lesser General Public
**  License for more details.
**
**  You should have received a copy of the GNU Lesser General Public
**  License along with this library; if not, write to the Free Software
**  Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston, MA  02110-1301  USA
**
**  See http://www.geopsy.org for more information.
**
**  Created : 2003-05-12
**
***************************************************************************/

#ifndef QTB_Line2D_H
#define QTB_Line2D_H

#include "qtbpoint2d.h"
#include "qtbtoolsdllexport.h"

class QTBTOOLS_EXPORT QtbLine2D
{
public:
  QtbLine2D( double c );
  QtbLine2D( double b, double c );
  QtbLine2D( double x1, double y1, double az );
  ~QtbLine2D() {}

  QtbPoint2D intersect( QtbLine2D& o, bool& ok );
protected:
  double _a, _b, _c;
};

#endif
