/***************************************************************************
**
**  Copyright (C) 2002-2009 Marc Wathelet. All rights reserved.
**
**  This file is part of qtbtools.
**
**  This library is free software; you can redistribute it and/or
**  modify it under the terms of the GNU Lesser General Public
**  License as published by the Free Software Foundation; either
**  version 2.1 of the License, or (at your option) any later version.
**
**  This file is distributed in the hope that it will be useful, but WITHOUT
**  ANY WARRANTY; without even the implied warranty of MERCHANTABILITY or
**  FITNESS FOR A PARTICULAR PURPOSE. See the GNU Lesser General Public
**  License for more details.
**
**  You should have received a copy of the GNU Lesser General Public
**  License along with this library; if not, write to the Free Software
**  Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston, MA  02110-1301  USA
**
**  See http://www.geopsy.org for more information.
**
**  Created : 2009-03-15
**
***************************************************************************/

#include "qtblineparser.h"
#include "qtbtrace.h"
#include "qtbmemorychecker.h"

/*!
  \class QtbLineParser qtblineparser.h
  \brief Brief description of class still missing

  Full description of class still missing
*/

/*!
  Description of constructor still missing
*/
QtbLineParser::QtbLineParser()
{
  QTB_TRACE;
  _ptr = 0;
}

/*!
  Description of constructor still missing
*/
QtbLineParser::QtbLineParser( QString str )
{
  QTB_TRACE;
  _str = str;
  _strSection.set( _str );
  _ptr = 0;
}

void QtbLineParser::setString( QString str )
{
  QTB_TRACE;
  _str = str;
  _strSection.set( _str );
  _values.clear();
  _ptr = 0;
}

/*!
  Parses all and returns number of items
*/
int QtbLineParser::count()
{
  QTB_TRACE;
  int index=_values.count();
  while(parse(index)!=QtbStringSection::null) {
    index++;
  }
  return _values.count();
}

const QtbStringSection& QtbLineParser::parse( int index )
{
  QTB_TRACE;
  QtbStringSection field;
  for( int i=_values.count(); i<=index; i++ ) {
    field = _strSection.nextField( _ptr );
    if ( field.isValid() ) {
      _values.append( field );
    } else {
      return QtbStringSection::null;
    }
  }
  return _values.at(index);
}
