/***************************************************************************
**
**  Copyright (C) 2002-2009 Marc Wathelet. All rights reserved.
**
**  This file is part of qtbtools.
**
**  This library is free software; you can redistribute it and/or
**  modify it under the terms of the GNU Lesser General Public
**  License as published by the Free Software Foundation; either
**  version 2.1 of the License, or (at your option) any later version.
**
**  This file is distributed in the hope that it will be useful, but WITHOUT
**  ANY WARRANTY; without even the implied warranty of MERCHANTABILITY or
**  FITNESS FOR A PARTICULAR PURPOSE. See the GNU Lesser General Public
**  License for more details.
**
**  You should have received a copy of the GNU Lesser General Public
**  License along with this library; if not, write to the Free Software
**  Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston, MA  02110-1301  USA
**
**  See http://www.geopsy.org for more information.
**
**  Created : 2007-01-29
**
***************************************************************************/

#ifndef QTB_MEMORYCHECKER_H
#define QTB_MEMORYCHECKER_H

#ifdef QTB_MEMORY_CHECKER
#include <new>

#include "qtbtoolsdllexport.h"

extern "C++" {

QTBTOOLS_EXPORT void* operator new ( std::size_t sz ) throw (std::bad_alloc);
QTBTOOLS_EXPORT void* operator new ( std::size_t sz, char* file, int line ) throw (std::bad_alloc);
QTBTOOLS_EXPORT void* operator new [] ( std::size_t sz ) throw (std::bad_alloc);
QTBTOOLS_EXPORT void* operator new [] ( std::size_t sz, char* file, int line ) throw (std::bad_alloc);

QTBTOOLS_EXPORT void operator delete ( void* v ) throw();
QTBTOOLS_EXPORT void operator delete [] ( void* v ) throw();

} // extern "C++"

// Convenient macro definitions with code localization
#define new new(__FILE__, __LINE__)
#endif // QTB_MEMORY_CHECKER

#endif // QTB_MEMORYCHECKER_H
