/***************************************************************************
**
**  Copyright (C) 2002-2009 Marc Wathelet. All rights reserved.
**
**  This file is part of qtbtools.
**
**  This library is free software; you can redistribute it and/or
**  modify it under the terms of the GNU Lesser General Public
**  License as published by the Free Software Foundation; either
**  version 2.1 of the License, or (at your option) any later version.
**
**  This file is distributed in the hope that it will be useful, but WITHOUT
**  ANY WARRANTY; without even the implied warranty of MERCHANTABILITY or
**  FITNESS FOR A PARTICULAR PURPOSE. See the GNU Lesser General Public
**  License for more details.
**
**  You should have received a copy of the GNU Lesser General Public
**  License along with this library; if not, write to the Free Software
**  Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston, MA  02110-1301  USA
**
**  See http://www.geopsy.org for more information.
**
**  Created : 2007-02-08
**
***************************************************************************/

#include <QSettings>

#include "qtbpackageinfo.h"
#include "qtbtrace.h"

QList<QtbPackageInfo> * QtbPackageInfo::_list = 0;

/*!
  \class QtbPackageInfo qtbpackageinfo.h
  \brief Brief description of class still missing

  Full description of class still missing
*/

/*!
  Description of constructor still missing
*/
QtbPackageInfo::QtbPackageInfo( QString package,
                                QString binDir,
                                QString libDir,
                                QString includeDir,
                                QString shareDir,
                                QString version,
                                QString versionTime,
                                QString versionType,
                                QString distribution,
                                QString copyright,
                                QString contact )
{
  _package = package;
  _binDir = binDir;
  _libDir = libDir;
  _includeDir = includeDir;
  _shareDir = shareDir;
  _version = version;
  _versionTime = versionTime;
  _versionType = versionType;
  _distribution = distribution;
  _copyright = copyright;
  _contact = contact;
}

/*!
  Copy constructor
*/
QtbPackageInfo::QtbPackageInfo( const QtbPackageInfo& o)
{
  _package = o._package;
  _binDir = o._binDir;
  _libDir = o._libDir;
  _includeDir = o._includeDir;
  _shareDir = o._shareDir;
  _version = o._version;
  _versionTime = o._versionTime;
  _versionType = o._versionType;
  _distribution = o._distribution;
  _copyright = o._copyright;
  _contact = o._contact;
}

QString QtbPackageInfo::getInstallDir( QString organization, QString package, QString dir, QString defaultDir)
{
  QSettings reg(organization, package);
  reg.beginGroup("installpaths");
  if (reg.contains(dir)) {
    return reg.value(dir).toString();
  } else {
    return defaultDir;
  }
}

QList<QtbPackageInfo> * QtbPackageInfo::list()
{
  if (!_list) _list = new QList<QtbPackageInfo>;
  return _list;
}

const QtbPackageInfo * QtbPackageInfo::package( QString package)
{
  for (QList<QtbPackageInfo>::iterator it=QtbPackageInfo::_list->begin();it!=QtbPackageInfo::_list->end(); it++ ) {
    if(package == it->package() ) {
      return &(*it);
    }
  }
  return 0;
}

