/***************************************************************************
**
**  Copyright (C) 2002-2009 Marc Wathelet. All rights reserved.
**
**  This file is part of qtbtools.
**
**  This library is free software; you can redistribute it and/or
**  modify it under the terms of the GNU Lesser General Public
**  License as published by the Free Software Foundation; either
**  version 2.1 of the License, or (at your option) any later version.
**
**  This file is distributed in the hope that it will be useful, but WITHOUT
**  ANY WARRANTY; without even the implied warranty of MERCHANTABILITY or
**  FITNESS FOR A PARTICULAR PURPOSE. See the GNU Lesser General Public
**  License for more details.
**
**  You should have received a copy of the GNU Lesser General Public
**  License along with this library; if not, write to the Free Software
**  Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston, MA  02110-1301  USA
**
**  See http://www.geopsy.org for more information.
**
**  Created : 2006-06-08
**
***************************************************************************/

#ifndef QTB_PATHTRANSLATOR_H
#define QTB_PATHTRANSLATOR_H

#include <QFileInfo>
#include <QMap>
#include <QStack>

#include "qtbtoolsdllexport.h"
#include "qtbtranslations.h"

class QTBTOOLS_EXPORT QtbPathTranslator : private QMap<QString, QString>
{
  QTB_TRANSLATIONS("QtbPathTranslator");
public:
  QtbPathTranslator() {}
  ~QtbPathTranslator() {}

  QString translate( const QString& originalFile, const QString& title, const QString& fileType);
  void addPath( QString obsoletePath, QString newPath );
private:
  QString platformIndependantPath( QString path );
  QString askPath ( const QFileInfo& file, const QString& title, const QString& fileType, const QString& directory = QString::null );
  static QString dirName( QString path );
  static bool isRoot( QString path );
};

#endif // QTB_PATHTRANSLATOR_H
