/***************************************************************************
**
**  Copyright (C) 2002-2009 Marc Wathelet. All rights reserved.
**
**  This file is part of qtbtools.
**
**  This library is free software; you can redistribute it and/or
**  modify it under the terms of the GNU Lesser General Public
**  License as published by the Free Software Foundation; either
**  version 2.1 of the License, or (at your option) any later version.
**
**  This file is distributed in the hope that it will be useful, but WITHOUT
**  ANY WARRANTY; without even the implied warranty of MERCHANTABILITY or
**  FITNESS FOR A PARTICULAR PURPOSE. See the GNU Lesser General Public
**  License for more details.
**
**  You should have received a copy of the GNU Lesser General Public
**  License along with this library; if not, write to the Free Software
**  Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston, MA  02110-1301  USA
**
**  See http://www.geopsy.org for more information.
**
**  Created : 2004-05-28
**
***************************************************************************/

#ifndef QTB_Segment2D_H
#define QTB_Segment2D_H

#include "qtbtoolsdllexport.h"
#include "qtbpoint2d.h"
#include "qtbrect.h"

class QTBTOOLS_EXPORT QtbSegment2D
{
public:
  QtbSegment2D() {}
  QtbSegment2D(QtbPoint2D& p1, QtbPoint2D& p2) {set(p1,p2);}
  QtbSegment2D(double x1, double y1, double x2, double y2) {set(x1, y1, x2, y2);}

  bool intersect(const QtbSegment2D& seg, QtbPoint2D& p) const;
  double distanceTo(QtbPoint2D& p) const;
  QtbPoint2D p1() const {return _p1;}
  QtbPoint2D p2() const {return _p2;}
  void set(const QtbPoint2D& p1, const QtbPoint2D& p2);
  void set(double x1, double y1, double x2, double y2);
  bool includes(QtbPoint2D& p) const;
  double length() const {return _p1.distanceTo(_p2);}
protected:
  QtbPoint2D _p1,_p2;
  QtbRect _limits;
};

#endif
