/***************************************************************************
**
**  Copyright (C) 2002-2009 Marc Wathelet. All rights reserved.
**
**  This file is part of qtbtools.
**
**  This library is free software; you can redistribute it and/or
**  modify it under the terms of the GNU Lesser General Public
**  License as published by the Free Software Foundation; either
**  version 2.1 of the License, or (at your option) any later version.
**
**  This file is distributed in the hope that it will be useful, but WITHOUT
**  ANY WARRANTY; without even the implied warranty of MERCHANTABILITY or
**  FITNESS FOR A PARTICULAR PURPOSE. See the GNU Lesser General Public
**  License for more details.
**
**  You should have received a copy of the GNU Lesser General Public
**  License along with this library; if not, write to the Free Software
**  Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston, MA  02110-1301  USA
**
**  See http://www.geopsy.org for more information.
**
**  Created : 2006-05-17
**
***************************************************************************/

#include "qtbsharedobject.h"

/*!
  \class QtbSharedObject qtbsharedobject.h
  \brief A simple shared object

  Probably not used anymore, QSharedObject is probably equivalent.
*/

/*!
  \fn QtbSharedObject::addReference()

  Call this function every time the object is used. The reference counter is increased by one.
*/

/*!
  \fn QtbSharedObject::removeReference()

  Call this function every time the object is not used anymore and you do not want to delete it immediately.
  If the reference counter reach 0, it returns true.
*/

/*!
  \fn QtbSharedObject::removeReference(QtbSharedObject *)

  Call this function every time the object is not used anymore and you want to delete it.
  If the reference counter reach 0, the object is automatically deleted.
*/
