/***************************************************************************
**
**  Copyright (C) 2002-2009 Marc Wathelet. All rights reserved.
**
**  This file is part of qtbtools.
**
**  This library is free software; you can redistribute it and/or
**  modify it under the terms of the GNU Lesser General Public
**  License as published by the Free Software Foundation; either
**  version 2.1 of the License, or (at your option) any later version.
**
**  This file is distributed in the hope that it will be useful, but WITHOUT
**  ANY WARRANTY; without even the implied warranty of MERCHANTABILITY or
**  FITNESS FOR A PARTICULAR PURPOSE. See the GNU Lesser General Public
**  License for more details.
**
**  You should have received a copy of the GNU Lesser General Public
**  License along with this library; if not, write to the Free Software
**  Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston, MA  02110-1301  USA
**
**  See http://www.geopsy.org for more information.
**
**  Created : 2007-02-23
**
***************************************************************************/

#include <QString>

#include "qtbsmoothingparameters.h"
#include "qtbtrace.h"

/*!
  \class QtbSmoothingParameters qtbsmoothingparameters.h
  \brief Brief description of class still missing

  Full description of class still missing
*/

/*!
  Description of constructor still missing
*/
QtbSmoothingParameters::QtbSmoothingParameters()
{
  QTB_TRACE;
  _type=KonnoOhmachi;
  _constant=40.0;
}

void QtbSmoothingParameters::set(QString type, double value)
{
  QTB_TRACE;
  type=type.toLower();
  if (type.contains("konno")) {
    _type=KonnoOhmachi;
    _constant=value;
  }
  else if (type.contains("constant")) {
    _type=Constant;
    _constant=value;
  }
  else if (type.contains("proportional")) {
    _type=Proportional;
    _constant=value*0.01;
  }
  else _type=NoSmoothing;
}
