/***************************************************************************
**
**  Copyright (C) 2002-2009 Marc Wathelet. All rights reserved.
**
**  This file is part of qtbtools.
**
**  This library is free software; you can redistribute it and/or
**  modify it under the terms of the GNU Lesser General Public
**  License as published by the Free Software Foundation; either
**  version 2.1 of the License, or (at your option) any later version.
**
**  This file is distributed in the hope that it will be useful, but WITHOUT
**  ANY WARRANTY; without even the implied warranty of MERCHANTABILITY or
**  FITNESS FOR A PARTICULAR PURPOSE. See the GNU Lesser General Public
**  License for more details.
**
**  You should have received a copy of the GNU Lesser General Public
**  License along with this library; if not, write to the Free Software
**  Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston, MA  02110-1301  USA
**
**  See http://www.geopsy.org for more information.
**
**  Created : 2009-07-01
**
***************************************************************************/

#include <math.h>

#include "qtbstatistics.h"
#include "qtbtrace.h"
#include "qtbmemorychecker.h"

/*!
  \class QtbStatistics qtbstatistics.h
  \brief Brief description of class still missing

  Full description of class still missing
*/

/*!
  Description of constructor still missing
*/
QtbStatistics::QtbStatistics()
{
  reset();
}

void QtbStatistics::add(double val)
{
  _sum+=val;
  _sum2+=val*val;
  if(val<_minimum) _minimum=val;
  if(val>_maximum) _maximum=val;
}

void QtbStatistics::set(double val)
{
  _sum=val;
  _sum2=val*val;
  _minimum=val;
  _maximum=val;
}

void QtbStatistics::reset()
{
  _sum=0.0;
  _sum2=0.0;
  _minimum=-1e99;
  _maximum=1e99;
}

double QtbStatistics::mean(int count) const
{
  switch(count) {
  case 0:
    return 0.0;
  case 1:
    return _sum;
  default:
    return _sum/count;
  }
}

double QtbStatistics::stddev(int count) const
{
  if(count<2) {
    return 0.0;
  } else {
    double s=(_sum2-_sum*_sum/count)/(count-1);
    if(s<0.0) s=0.0;
    return sqrt(s);
  }
}
