/***************************************************************************
**
**  Copyright (C) 2002-2009 Marc Wathelet. All rights reserved.
**
**  This file is part of qtbtools.
**
**  This library is free software; you can redistribute it and/or
**  modify it under the terms of the GNU Lesser General Public
**  License as published by the Free Software Foundation; either
**  version 2.1 of the License, or (at your option) any later version.
**
**  This file is distributed in the hope that it will be useful, but WITHOUT
**  ANY WARRANTY; without even the implied warranty of MERCHANTABILITY or
**  FITNESS FOR A PARTICULAR PURPOSE. See the GNU Lesser General Public
**  License for more details.
**
**  You should have received a copy of the GNU Lesser General Public
**  License along with this library; if not, write to the Free Software
**  Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston, MA  02110-1301  USA
**
**  See http://www.geopsy.org for more information.
**
**  Created : 2009-07-01
**
***************************************************************************/

#ifndef QTB_STATISTICS_H
#define QTB_STATISTICS_H

#include "qtbtoolsdllexport.h"

class QTBTOOLS_EXPORT QtbStatistics
{
public:
  QtbStatistics();

  void add(double val);
  void set(double val);
  void reset();

  double mean(int count) const;
  double stddev(int count) const;
  double minimum() const {return _minimum;}
  double maximum() const {return _maximum;}
private:
  double _sum, _sum2;
  double _minimum;
  double _maximum;
};

#endif // QTB_STATISTICS_H
