/***************************************************************************
**
**  Copyright (C) 2002-2009 Marc Wathelet. All rights reserved.
**
**  This file is part of qtbtools.
**
**  This library is free software; you can redistribute it and/or
**  modify it under the terms of the GNU Lesser General Public
**  License as published by the Free Software Foundation; either
**  version 2.1 of the License, or (at your option) any later version.
**
**  This file is distributed in the hope that it will be useful, but WITHOUT
**  ANY WARRANTY; without even the implied warranty of MERCHANTABILITY or
**  FITNESS FOR A PARTICULAR PURPOSE. See the GNU Lesser General Public
**  License for more details.
**
**  You should have received a copy of the GNU Lesser General Public
**  License along with this library; if not, write to the Free Software
**  Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston, MA  02110-1301  USA
**
**  See http://www.geopsy.org for more information.
**
**  Created : 2006-09-25
**
***************************************************************************/

#include "qtbstatpoint.h"

const QString QtbStatPoint::xmlStatPointTag = "StatPoint";

/*!
  \class QtbStatPoint qtbstatpoint.h
  \brief Brief description of class still missing

  Full description of class still missing
*/

/*!
  \fn QtbStatPoint::QtbStatPoint()
  Description of constructor still missing
*/

void QtbStatPoint::xml_writeProperties(XML_WRITEPROPERTIES_ARGS) const
{
  QTB_TRACE;
  Q_UNUSED(context);
  writeProperty(s,"x",_x);
  QtbStatValue::xml_writeProperties(s, context);
}

QtbXMLMember QtbStatPoint::xml_member(XML_MEMBER_ARGS)
{
  QTB_TRACE;
  Q_UNUSED(context);
  if (tag=="x") return QtbXMLMember(0);
  else return QtbStatValue::xml_member(tag, attributes, context)+1;
}

bool QtbStatPoint::xml_setProperty(XML_SETPROPERTY_ARGS)
{
  QTB_TRACE;
  Q_UNUSED(context);
  switch (memberID) {
  case 0: _x=content.toDouble(); return true;
  default: return QtbStatValue::xml_setProperty(memberID-1, attributes, content, context);
  }
}

QString QtbStatPoint::toString(int precision) const
{
  QTB_TRACE;
  QString tmp;
  tmp+=QString::number(_x,'g',precision);
  tmp+=" ";
  tmp+=QString::number(mean(),'g',precision);
  tmp+=" ";
  tmp+=QString::number(stddev(),'g',precision);
  tmp+=" ";
  if (isValid()) {
    tmp+=QString::number(weight(),'g',precision);
  } else {
    tmp+="0";
  }
  return tmp;
}

bool QtbStatPoint::fromString(QtbStringSection str)
{
  QTB_TRACE;
  const QChar * ptr=0;
  QtbStringSection f;
  f=str.firstField(ptr);
  if (f.isValid()) _x=f.toDouble(); else return false;
  f=str.nextField(ptr);
  if (f.isValid()) setMean( f.toDouble() ); else return false;
  f=str.nextField(ptr);
  if (f.isValid()) setStddev( f.toDouble() ); else return false;
  f=str.nextField(ptr);
  if (f.isValid()) {
    double w = f.toDouble();
    if(w==0.0) {
      setValid(false);
      setWeight(1.0);
    } else {
      setValid(true);
      setWeight(w);
    }
  } else return false;
  return true;
}
