/***************************************************************************
**
**  Copyright (C) 2002-2009 Marc Wathelet. All rights reserved.
**
**  This file is part of qtbtools.
**
**  This library is free software; you can redistribute it and/or
**  modify it under the terms of the GNU Lesser General Public
**  License as published by the Free Software Foundation; either
**  version 2.1 of the License, or (at your option) any later version.
**
**  This file is distributed in the hope that it will be useful, but WITHOUT
**  ANY WARRANTY; without even the implied warranty of MERCHANTABILITY or
**  FITNESS FOR A PARTICULAR PURPOSE. See the GNU Lesser General Public
**  License for more details.
**
**  You should have received a copy of the GNU Lesser General Public
**  License along with this library; if not, write to the Free Software
**  Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston, MA  02110-1301  USA
**
**  See http://www.geopsy.org for more information.
**
**  Created : 2007-02-09
**
***************************************************************************/

#include "qtbstreamredirection.h"
#include "qtbcoreapplication.h"

/*!
  \class QtbStreamRedirection qtbstreamredirection.h
  \brief Begin and end stream redirection automatically

  Begin and end stream redirection automatically when this object is deleted. Usefull to avoid multiple calls to
  qtbApp.restoreStream() in a function with several return points.
*/

/*!
  Description of constructor still missing
*/
QtbStreamRedirection::QtbStreamRedirection( QThread * t )
{
  QTB_TRACE;
  qtbApp.redirectStream( &qtbApp.stream(t) );
}

QtbStreamRedirection::QtbStreamRedirection( QtbLogStream * s )
{
  QTB_TRACE;
  qtbApp.redirectStream( s );
}

/*!
  Description of destructor still missing
*/
QtbStreamRedirection::~QtbStreamRedirection()
{
  QTB_TRACE;
  qtbApp.restoreStream();
}
