/***************************************************************************
**
**  Copyright (C) 2002-2009 Marc Wathelet. All rights reserved.
**
**  This file is part of qtbtools.
**
**  This library is free software; you can redistribute it and/or
**  modify it under the terms of the GNU Lesser General Public
**  License as published by the Free Software Foundation; either
**  version 2.1 of the License, or (at your option) any later version.
**
**  This file is distributed in the hope that it will be useful, but WITHOUT
**  ANY WARRANTY; without even the implied warranty of MERCHANTABILITY or
**  FITNESS FOR A PARTICULAR PURPOSE. See the GNU Lesser General Public
**  License for more details.
**
**  You should have received a copy of the GNU Lesser General Public
**  License along with this library; if not, write to the Free Software
**  Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston, MA  02110-1301  USA
**
**  See http://www.geopsy.org for more information.
**
**  Created : 2004-10-28
**
***************************************************************************/

#ifndef QTB_ThreadTimer_H
#define QTB_ThreadTimer_H

#include <QTimer>
#include <QTime>

#include "qtbcoreapplication.h"
#include "qtbtoolsdllexport.h"

class QTBTOOLS_EXPORT QtbThreadTimer :  public QTimer
{
  Q_OBJECT
public:
  QtbThreadTimer();
  ~QtbThreadTimer() {}
  int nRunningThreads() {return _nofRunningThreads;}
public slots:
  void synchronize();
  void threadStarted();
  void threadStopped();
private:
  int _nofRunningThreads;
signals:
  void synchroTimeout();
};

#endif
