/***************************************************************************
**
**  Copyright (C) 2002-2009 Marc Wathelet. All rights reserved.
**
**  This file is part of qtbtools.
**
**  This library is free software; you can redistribute it and/or
**  modify it under the terms of the GNU Lesser General Public
**  License as published by the Free Software Foundation; either
**  version 2.1 of the License, or (at your option) any later version.
**
**  This file is distributed in the hope that it will be useful, but WITHOUT
**  ANY WARRANTY; without even the implied warranty of MERCHANTABILITY or
**  FITNESS FOR A PARTICULAR PURPOSE. See the GNU Lesser General Public
**  License for more details.
**
**  You should have received a copy of the GNU Lesser General Public
**  License along with this library; if not, write to the Free Software
**  Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston, MA  02110-1301  USA
**
**  See http://www.geopsy.org for more information.
**
**  Created : 2002-09-18
**
***************************************************************************/

#ifndef QTB_TIME_H
#define QTB_TIME_H

#include <QString>
#include <QDateTime>

#include "qtbtoolsdllexport.h"

#ifndef CAP
/************************************************/
/* an older struct remaining from PITSA         */
/*************************************************/
typedef struct  Time  {
                int           yr;     /* year         */
                int           mo;     /* month        */
                int           day;    /* day          */
                int           hr;     /* hour         */
                int           mn;     /* minute       */
                float         sec;    /* second       */
                int           base;   /* GMT, DST,etc.*/
                } TIME;
#endif

class QTBTOOLS_EXPORT QtbTime
{
public:
  static QString secondsToTime( double sec, int numberPrecision=-1 );
  static double timeToSeconds( QString str );
  static TIME addSecs( QDateTime dt, double secs );
  static QString addSecs( QDateTime dt, double secs, QString format );
private:
  inline static bool timeToSecondsSign( const QChar * p, int& i, int n );
  static double timeToSecondsError(QString str, int pos);
};

#endif // QTB_TIME_H
