/***************************************************************************
**
**  Copyright (C) 2002-2009 Marc Wathelet. All rights reserved.
**
**  This file is part of qtbtools.
**
**  This library is free software; you can redistribute it and/or
**  modify it under the terms of the GNU Lesser General Public
**  License as published by the Free Software Foundation; either
**  version 2.1 of the License, or (at your option) any later version.
**
**  This file is distributed in the hope that it will be useful, but WITHOUT
**  ANY WARRANTY; without even the implied warranty of MERCHANTABILITY or
**  FITNESS FOR A PARTICULAR PURPOSE. See the GNU Lesser General Public
**  License for more details.
**
**  You should have received a copy of the GNU Lesser General Public
**  License along with this library; if not, write to the Free Software
**  Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston, MA  02110-1301  USA
**
**  See http://www.geopsy.org for more information.
**
**  Created : 2004-12-12
**
***************************************************************************/

#include <QSettings>

#include "qtbtools.h"
#include "qtbpackageinfo.h"
#include "qtbtoolsversion.h"
#include "qtbtoolsinstallpath.h"
#include "qtbmemorychecker.h"

/*!
  \mainpage qtbtools library

  qtbtools is a C++ library containing usufull objects without any reference to a graphical user interface (to X server
  under Linux).

  Geometrical objects:
    \li QtbAngle
    \li QtbPoint
    \li QtbPoint2D
    \li QtbCircle
    \li QtbCurve
    \li QtbGrid2D
    \li QtbIrregularGrid2D
    \li QtbLine2D
    \li QtbRect
    \li QtbSegment2D

  Mathemetical objects:
    \li QtbComplex
    \li QtbGaussDistribution
    \li QtbMatrix
    \li QtbProcessStatistics
    \li QtbStationaryProcess
    \li QtbRandom
    \li QtbSpecFunctions
    \li QtbStatComparator
    \li QtbStatPoint
    \li QtbStatValue

  Optimisation and search objects:
    \li QtbGridSearch
    \li QtbConcentricSearch
    \li QtbSimplex

  User interaction objects (GUIless but with auto integration with GUI):
    \li QtbLogStream
    \li QtbMessage
    \li QtbTranslations

  Miscelaneous objects:
    \li QtbStringSection
    \li QtbTreeItem
    \li QtbCache
    \li QtbCacheItem
    \li QtbFile
    \li QtbPathTranslator
    \li QtbTar
    \li QtbXMLClass
*/

QTB_PACKAGE_INFO(qtbtools, QTBTOOLS);
