/***************************************************************************
**
**  Copyright (C) 2002-2009 Marc Wathelet. All rights reserved.
**
**  This file is part of qtbtools.
**
**  This library is free software; you can redistribute it and/or
**  modify it under the terms of the GNU Lesser General Public
**  License as published by the Free Software Foundation; either
**  version 2.1 of the License, or (at your option) any later version.
**
**  This file is distributed in the hope that it will be useful, but WITHOUT
**  ANY WARRANTY; without even the implied warranty of MERCHANTABILITY or
**  FITNESS FOR A PARTICULAR PURPOSE. See the GNU Lesser General Public
**  License for more details.
**
**  You should have received a copy of the GNU Lesser General Public
**  License along with this library; if not, write to the Free Software
**  Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston, MA  02110-1301  USA
**
**  See http://www.geopsy.org for more information.
**
**  Created : 2004-12-12
**
***************************************************************************/

#ifndef QTB_TOOLS_H
#define QTB_TOOLS_H

#include <QString>
#include <QVector>
#include <QtAlgorithms>

#include "qtbtoolsdllexport.h"

QTBTOOLS_EXPORT const char * libqtbtoolsVersion();


namespace Qtb {
  template <typename T> void uniq( QList<T>& list );
  template <typename T> void uniq( QVector<T>& list );
  template <typename T> void swap( T& value1, T& value2 );
}

template <typename T> void Qtb::uniq( QList<T>& list )
{
  qSort( list.begin(), list.end() );
  for ( int i = 1;i < list.count(); ) {
    if ( list.at( i - 1 ) == list.at( i ) )
      list.removeAt( i );
    else
      i++;
  }
}

template <typename T> void Qtb::uniq( QVector<T>& v )
{
  qSort( v.begin(), v.end() );
  for ( int i = 1;i < v.count(); ) {
    if ( v.at( i - 1 ) == v.at( i ) )
      v.remove( i );
    else
      i++;
  }
}

template <typename T> void Qtb::swap( T& value1, T& value2 )
{
  T tmp = value1;
  value1 = value2;
  value2 = tmp;
}

#endif // QTB_TOOLS_H
