/***************************************************************************
**
**  Copyright (C) 2002-2009 Marc Wathelet. All rights reserved.
**
**  This file is part of qtbtools.
**
**  This library is free software; you can redistribute it and/or
**  modify it under the terms of the GNU Lesser General Public
**  License as published by the Free Software Foundation; either
**  version 2.1 of the License, or (at your option) any later version.
**
**  This file is distributed in the hope that it will be useful, but WITHOUT
**  ANY WARRANTY; without even the implied warranty of MERCHANTABILITY or
**  FITNESS FOR A PARTICULAR PURPOSE. See the GNU Lesser General Public
**  License for more details.
**
**  You should have received a copy of the GNU Lesser General Public
**  License along with this library; if not, write to the Free Software
**  Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston, MA  02110-1301  USA
**
**  See http://www.geopsy.org for more information.
**
**  Created : 2008-10-20
**
***************************************************************************/

#include "qtbtracebug.h"
#include "qtbthread.h"
#include "qtbcoreapplication.h"
#include "qtbmemorychecker.h"

/*!
  \class QtbTraceBug qtbtracebug.h
  \brief Brief description of class still missing

  Full description of class still missing
*/

QStack<QtbTraceBug *> QtbTraceBug::_mainStack;

/*!
  Description of constructor still missing
*/
QtbTraceBug::QtbTraceBug( const QtbTraceStamp * s )
{
  QThread * t = QThread::currentThread();
  QtbThread * myt = qobject_cast<QtbThread *>(t);
  if (myt) {
    _myStack = myt->bugStack();
    _myStack->push(this);
  } else if (t==qtbApp.mainThread()) {
    _myStack = &_mainStack;
    _myStack->push(this);
  } else {
    _myStack = 0;
  }
  _stamp = s;
}

/*!
  Description of destructor still missing
*/
QtbTraceBug::~QtbTraceBug()
{
  if (_myStack) {
    _myStack->pop();
  }
}

QString QtbTraceBug::backTrace( const QStack<QtbTraceBug *> * stack )
{
  QString list;
  for (int i=stack->count()-1;i>=0;i--) {
    list += stack->at(i)->toString();
  }
  return list;
}

QString QtbTraceBug::toString() const
{
  QString str;
  str+=_stamp->toString() + "\n";
  for(QList<QtbTraceInfo>::const_iterator it = _infos.begin();it!=_infos.end();it++) {
    str+="  "+it->toString() + "\n";
  }
  return str;
}
