/***************************************************************************
**
**  Copyright (C) 2002-2009 Marc Wathelet. All rights reserved.
**
**  This file is part of qtbtools.
**
**  This library is free software; you can redistribute it and/or
**  modify it under the terms of the GNU Lesser General Public
**  License as published by the Free Software Foundation; either
**  version 2.1 of the License, or (at your option) any later version.
**
**  This file is distributed in the hope that it will be useful, but WITHOUT
**  ANY WARRANTY; without even the implied warranty of MERCHANTABILITY or
**  FITNESS FOR A PARTICULAR PURPOSE. See the GNU Lesser General Public
**  License for more details.
**
**  You should have received a copy of the GNU Lesser General Public
**  License along with this library; if not, write to the Free Software
**  Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston, MA  02110-1301  USA
**
**  See http://www.geopsy.org for more information.
**
**  Created : 2008-10-20
**
***************************************************************************/

#include "qtbtraceinfo.h"
#include "qtbmemorychecker.h"

/*!
  \class QtbTraceInfo qtbtraceinfo.h
  \brief Abstract class for all types of trace information

  Abstract class for all types of trace information. toString() returns a string
  that will be inserted in backtraces in case of error.
*/

QString QtbTraceInfo::toString() const
{
  static const QString fmt("%1=%2");
  switch(_val.type()) {
  case QVariant::ULongLong:
  case QVariant::UInt:
    return fmt.arg(_valName).arg(_val.toUInt(), 0, 16);
  case QVariant::Bool:
    return fmt.arg(_valName).arg(_val.toBool() ? "true" : "false");
  default:
    return fmt.arg(_valName).arg(_val.toString());
  }
}
