/***************************************************************************
**
**  Copyright (C) 2002-2009 Marc Wathelet. All rights reserved.
**
**  This file is part of qtbtools.
**
**  This library is free software; you can redistribute it and/or
**  modify it under the terms of the GNU Lesser General Public
**  License as published by the Free Software Foundation; either
**  version 2.1 of the License, or (at your option) any later version.
**
**  This file is distributed in the hope that it will be useful, but WITHOUT
**  ANY WARRANTY; without even the implied warranty of MERCHANTABILITY or
**  FITNESS FOR A PARTICULAR PURPOSE. See the GNU Lesser General Public
**  License for more details.
**
**  You should have received a copy of the GNU Lesser General Public
**  License along with this library; if not, write to the Free Software
**  Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston, MA  02110-1301  USA
**
**  See http://www.geopsy.org for more information.
**
**  Created : 2005-08-17
**
***************************************************************************/

#ifndef QTB_TRANSLATIONS_H
#define QTB_TRANSLATIONS_H

#include <QCoreApplication>
#include <QDir>

#include "qtbtoolsdllexport.h"
#include "qtbtrace.h"

inline QString translate(QString context, const char * string, const char  * comment=0)
{
  QTB_TRACE;
  return QCoreApplication::translate(context.toAscii().data(), string, comment);
}

inline QString translate(const char * context, const char * string, const char  * comment=0)
{
  QTB_TRACE;
  return QCoreApplication::translate(context, string, comment);
}

/*
  Use this MACRO in all class definitions where there are no QObject inheritance
*/
#define QTB_TRANSLATIONS(context) \
  QString tr(const char * s, const char * comments=0) const {return ::translate(context, s, comments);}
#define QTB_TRANSLATIONS_STATIC(context) \
  static QString tr(const char * s, const char * comments=0) {return ::translate(context, s, comments);}

#endif // QTB_TRANSLATIONS_H
