/***************************************************************************
**
**  Copyright (C) 2002-2009 Marc Wathelet. All rights reserved.
**
**  This file is part of qtbtools.
**
**  This library is free software; you can redistribute it and/or
**  modify it under the terms of the GNU Lesser General Public
**  License as published by the Free Software Foundation; either
**  version 2.1 of the License, or (at your option) any later version.
**
**  This file is distributed in the hope that it will be useful, but WITHOUT
**  ANY WARRANTY; without even the implied warranty of MERCHANTABILITY or
**  FITNESS FOR A PARTICULAR PURPOSE. See the GNU Lesser General Public
**  License for more details.
**
**  You should have received a copy of the GNU Lesser General Public
**  License along with this library; if not, write to the Free Software
**  Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston, MA  02110-1301  USA
**
**  See http://www.geopsy.org for more information.
**
**  Created : 2007-04-25
**
***************************************************************************/

#ifndef QTB_XMLBYTEARRAYSTREAM_H
#define QTB_XMLBYTEARRAYSTREAM_H

#include <QMap>

#include "qtbxmlstream.h"
#include "qtbtoolsdllexport.h"
#include "qtbtranslations.h"

class QTBTOOLS_EXPORT QtbXMLByteArrayStream : public QtbXMLStream
{
  QTB_TRANSLATIONS("QtbXMLByteArrayStream");
public:
  QtbXMLByteArrayStream( QIODevice::OpenMode m );
  ~QtbXMLByteArrayStream();

  bool open(QByteArray data);
  void addXmlFile();
  QByteArray data() const { return _data; }

  virtual bool isMultiFile() const { return true; };
  virtual void addFile( QString fileName, const QByteArray& data );
  virtual bool file( QString fileName, QByteArray& data );
private:
  QIODevice::OpenMode _mode;
  QByteArray * _xml;
  QByteArray _data;
  QMap<QString, QByteArray> _files;
  qint64 _lastPos;
};

inline void QtbXMLByteArrayStream::addXmlFile()
{
  QTB_TRACE;
  addFile( "contents.xml", *_xml );
}

#endif // QTB_XMLBYTEARRAYSTREAM_H
