/***************************************************************************
**
**  Copyright (C) 2002-2009 Marc Wathelet. All rights reserved.
**
**  This file is part of qtbwave.
**
**  This file may be distributed and/or modified under the terms of the
**  GNU General Public License version 2 or 3 as published by the Free
**  Software Foundation and appearing in the file LICENSE.GPL included
**  in the packaging of this file.
**
**  This file is distributed in the hope that it will be useful, but WITHOUT
**  ANY WARRANTY; without even the implied warranty of MERCHANTABILITY or
**  FITNESS FOR A PARTICULAR PURPOSE. See the GNU General Public License for
**  more details.
**
**  See http://www.geopsy.org for more information.
**
**  Created : 2004-11-02
**
***************************************************************************/

#ifndef QTB_ARRIVALTIME_H
#define QTB_ARRIVALTIME_H

#include "qtbstatpoint.h"
#include "qtbwavedllexport.h"

class QTBWAVE_EXPORT QtbArrivalTime : public QtbStatPoint
{
public:
  QtbArrivalTime() {}
  QtbArrivalTime( double x, double time, double timeDev );
  virtual ~QtbArrivalTime() {}

  virtual const QString& xml_tagName() const { return xmlArrivalTimeTag;}
  static const QString xmlArrivalTimeTag;
};

inline QtbArrivalTime::QtbArrivalTime( double x, double time, double timeDev )
   : QtbStatPoint( x, time )
{
  QTB_TRACE;
  setStddev( timeDev );
}

#endif // QTB_ARRIVALTIME_H
