/***************************************************************************
**
**  Copyright (C) 2002-2009 Marc Wathelet. All rights reserved.
**
**  This file is part of qtbwave.
**
**  This file may be distributed and/or modified under the terms of the
**  GNU General Public License version 2 or 3 as published by the Free
**  Software Foundation and appearing in the file LICENSE.GPL included
**  in the packaging of this file.
**
**  This file is distributed in the hope that it will be useful, but WITHOUT
**  ANY WARRANTY; without even the implied warranty of MERCHANTABILITY or
**  FITNESS FOR A PARTICULAR PURPOSE. See the GNU General Public License for
**  more details.
**
**  See http://www.geopsy.org for more information.
**
**  Created : 2004-08-30
**
***************************************************************************/

#ifndef QTB_AsciiFilter_H
#define QTB_AsciiFilter_H

// Structure to store ASCII filters

class QtbAsciiFilter {
public:
  inline QtbAsciiFilter();
  ~QtbAsciiFilter() {}
  bool isFrequency;
  bool isVelocity;
  bool isMetre;
  bool autoSplit;
  QString acceptStr;
  QString rejectStr;
  int doStartLine;
  int doStopLine;
  int startLine;
  int stopLine;
  int xCol, yValCol, yErrCol, yWeightCol;  
};

inline QtbAsciiFilter::QtbAsciiFilter()
{
  QTB_TRACE;
  isFrequency=true;
  isVelocity=false;
  isMetre=true;
  autoSplit=false;
  acceptStr="";
  rejectStr="#";
  startLine=1;
  stopLine=2147483647;
  xCol=0;
  yValCol=1;
  yErrCol=2;
  yWeightCol=3;  
}


#endif
