/***************************************************************************
**
**  Copyright (C) 2002-2009 Marc Wathelet. All rights reserved.
**
**  This file is part of qtbwave.
**
**  This file may be distributed and/or modified under the terms of the
**  GNU General Public License version 2 or 3 as published by the Free
**  Software Foundation and appearing in the file LICENSE.GPL included
**  in the packaging of this file.
**
**  This file is distributed in the hope that it will be useful, but WITHOUT
**  ANY WARRANTY; without even the implied warranty of MERCHANTABILITY or
**  FITNESS FOR A PARTICULAR PURPOSE. See the GNU General Public License for
**  more details.
**
**  See http://www.geopsy.org for more information.
**
**  Created : 2009-02-04
**
***************************************************************************/

#ifndef QTB_AUTOCORRDISPERSION_H
#define QTB_AUTOCORRDISPERSION_H

#include "qtbautocorrengine.h"
#include "qtbwavedllexport.h"

class QTBWAVE_EXPORT QtbAutocorrDispersion : private QtbAutocorrEngine
{
public:
  void setRing( const QtbAutocorrRing& r ) { setVerticalRing( r ); }
  QVector<double> dispersion( const QtbFactoryPoint& autocorr, double kmin, double kmax );

  double y( double k );
  double derivative( double k );
private:
  double _autocorrRef;
};

#endif // QTB_AUTOCORRDISPERSION_H
