/***************************************************************************
**
**  Copyright (C) 2002-2009 Marc Wathelet. All rights reserved.
**
**  This file is part of qtbwave.
**
**  This file may be distributed and/or modified under the terms of the
**  GNU General Public License version 2 or 3 as published by the Free
**  Software Foundation and appearing in the file LICENSE.GPL included
**  in the packaging of this file.
**
**  This file is distributed in the hope that it will be useful, but WITHOUT
**  ANY WARRANTY; without even the implied warranty of MERCHANTABILITY or
**  FITNESS FOR A PARTICULAR PURPOSE. See the GNU General Public License for
**  more details.
**
**  See http://www.geopsy.org for more information.
**
**  Created : 2006-09-25
**
***************************************************************************/

#include "qtbautocorrring.h"

/*!
  \class QtbAutocorrRing qtbautocorrring.h
  \brief Brief description of class still missing

  Full description of class still missing
*/

const QString QtbAutocorrRing::xmlAutocorrRingTag= "AutocorrRing";

/*!
  \fn QtbAutocorrRing::QtbAutocorrRing()
  Default constructor (init zero rings)
*/

/*!
  \fn QtbAutocorrRing::QtbAutocorrRing( double rMin, double rMax )
  Init a ring with minium (\a rMin ) and maximum (\a rMax ) radii
*/

void QtbAutocorrRing::xml_writeProperties( XML_WRITEPROPERTIES_ARGS ) const
{
  QTB_TRACE;
  Q_UNUSED(context);
  writeProperty( s, "minRadius", _minRadius);
  writeProperty( s, "maxRadius", _maxRadius);
}

QtbXMLMember QtbAutocorrRing::xml_member( XML_MEMBER_ARGS )
{
  QTB_TRACE;
  Q_UNUSED(attributes)
  Q_UNUSED(context);
  if ( tag == "minRadius" ) return QtbXMLMember(0);
  else if ( tag == "maxRadius" ) return QtbXMLMember(1);
  else return QtbXMLMember(QtbXMLMember::Unknown);
}

bool QtbAutocorrRing::xml_setProperty( XML_SETPROPERTY_ARGS )
{
  QTB_TRACE;
  Q_UNUSED(attributes)
  Q_UNUSED(context);
  switch (memberID) {
  case 0: _minRadius=content.toDouble(); return true;
  case 1: _maxRadius=content.toDouble(); return true;
  default: return false;
  }
}
