/***************************************************************************
**
**  Copyright (C) 2002-2009 Marc Wathelet. All rights reserved.
**
**  This file is part of qtbwave.
**
**  This file may be distributed and/or modified under the terms of the
**  GNU General Public License version 2 or 3 as published by the Free
**  Software Foundation and appearing in the file LICENSE.GPL included
**  in the packaging of this file.
**
**  This file is distributed in the hope that it will be useful, but WITHOUT
**  ANY WARRANTY; without even the implied warranty of MERCHANTABILITY or
**  FITNESS FOR A PARTICULAR PURPOSE. See the GNU General Public License for
**  more details.
**
**  See http://www.geopsy.org for more information.
**
**  Created : 2004-10-22
**
***************************************************************************/

#ifndef QTB_MODALELLIPTICITY_H
#define QTB_MODALELLIPTICITY_H

#include "qtbwavedllexport.h"
#include "qtbmodalstorage.h"
#include "qtbstatvalue.h"
#include "qtbrayleigh.h"
#include "qtbrootsolver.h"

class QtbDispersion;

class QTBWAVE_EXPORT QtbEllipticity :  public QtbModalStorage
{
  QTB_TRANSLATIONS("QtbEllipticityFactory")
public:
  QtbEllipticity( int nModes, const QVector<double>* x ) : QtbModalStorage( nModes, x) {}

  QList<double> peaks( int modeIndex, QtbDispersion& disp, QtbRayleigh * waveModel);
  double peakMisfit( int modeIndex, const QtbStatValue& val, QtbDispersion& disp, QtbRayleigh * waveModel);
private:
  inline double refineMax( int modeIndex, int iOmega, QtbDispersion& disp,
                           QtbRootSolver<QtbRayleigh>& , bool& badSampling);
};

#endif // QTB_MODALELLIPTICITY_H
