/***************************************************************************
**
**  Copyright (C) 2002-2009 Marc Wathelet. All rights reserved.
**
**  This file is part of qtbwave.
**
**  This file may be distributed and/or modified under the terms of the
**  GNU General Public License version 2 or 3 as published by the Free
**  Software Foundation and appearing in the file LICENSE.GPL included
**  in the packaging of this file.
**
**  This file is distributed in the hope that it will be useful, but WITHOUT
**  ANY WARRANTY; without even the implied warranty of MERCHANTABILITY or
**  FITNESS FOR A PARTICULAR PURPOSE. See the GNU General Public License for
**  more details.
**
**  See http://www.geopsy.org for more information.
**
**  Created : 2006-10-03
**
***************************************************************************/

#include "qtbellipticityfactory.h"
#include "qtbmodalcurve.h"

/*!
  \class QtbEllipticityFactory qtbellipticityfactory.h
  \brief Brief description of class still missing

  Full description of class still missing
*/

QtbEllipticityFactory::QtbEllipticityFactory()
{
  QTB_TRACE;
  _values = 0;
}

QtbEllipticityFactory::~QtbEllipticityFactory()
{
  QTB_TRACE;
  delete _values;
}

void QtbEllipticityFactory::setMode ( const QtbMode& m )
{
  QTB_TRACE;
  upgrade( _values, m.index() );
}

const QtbValue * QtbEllipticityFactory::mode( const QtbMode& m) const
{
  return _values ? _values->mode( m.index() ) : 0;
}

double QtbEllipticityFactory::peakMisfit( const QtbStatValue& val, QtbDispersionFactory& disp, const QtbLayeredModel * model )
{
  QTB_TRACE;
  if (_values && disp.phaseRayleigh()) {
    QtbRayleigh rayleigh( model );
    // TODO generalize to n modes
    return _values->peakMisfit( 0, val, *disp.phaseRayleigh(), &rayleigh);
  } else return 0.0;
}
