/***************************************************************************
**
**  Copyright (C) 2002-2009 Marc Wathelet. All rights reserved.
**
**  This file is part of qtbwave.
**
**  This file may be distributed and/or modified under the terms of the
**  GNU General Public License version 2 or 3 as published by the Free
**  Software Foundation and appearing in the file LICENSE.GPL included
**  in the packaging of this file.
**
**  This file is distributed in the hope that it will be useful, but WITHOUT
**  ANY WARRANTY; without even the implied warranty of MERCHANTABILITY or
**  FITNESS FOR A PARTICULAR PURPOSE. See the GNU General Public License for
**  more details.
**
**  See http://www.geopsy.org for more information.
**
**  Created : 2006-10-03
**
***************************************************************************/

#ifndef QTB_ELLIPTICITYFACTORY_H
#define QTB_ELLIPTICITYFACTORY_H

#include "qtbdispersionfactory.h"
#include "qtbellipticity.h"
#include "qtbwavedllexport.h"

class QTBWAVE_EXPORT QtbEllipticityFactory : public QtbModalFactory
{
  QTB_TRANSLATIONS("QtbEllipticityFactory");
public:
  QtbEllipticityFactory();
  ~QtbEllipticityFactory();

  QtbEllipticity * values() { return _values; }

  double peakMisfit( const QtbStatValue& val, QtbDispersionFactory& disp, const QtbLayeredModel * model );

  virtual void setMode ( const QtbMode& m );
  virtual const QtbValue * mode( const QtbMode& m ) const;
  virtual int storageCount() const { return 1; }
  inline virtual QtbModalStorage * storage( int ) const;

  void log10() { _values->log10(); }
  void exp10() { _values->exp10(); }
protected:
  virtual QtbModalStorage * newStorage( int nModes ) { return new QtbEllipticity( nModes, x() ); }
private:
  QtbEllipticity * _values;
};

inline QtbModalStorage * QtbEllipticityFactory::storage( int ) const
{
  QTB_TRACE;
  return _values;
}

#endif // QTB_ELLIPTICITYFACTORY_H
