/***************************************************************************
**
**  Copyright (C) 2002-2009 Marc Wathelet. All rights reserved.
**
**  This file is part of qtbwave.
**
**  This file may be distributed and/or modified under the terms of the
**  GNU General Public License version 2 or 3 as published by the Free
**  Software Foundation and appearing in the file LICENSE.GPL included
**  in the packaging of this file.
**
**  This file is distributed in the hope that it will be useful, but WITHOUT
**  ANY WARRANTY; without even the implied warranty of MERCHANTABILITY or
**  FITNESS FOR A PARTICULAR PURPOSE. See the GNU General Public License for
**  more details.
**
**  See http://www.geopsy.org for more information.
**
**  Created : 2006-09-25
**
***************************************************************************/

#ifndef QTB_FACTORYPOINT_H
#define QTB_FACTORYPOINT_H

#include "qtbstatpoint.h"
#include "qtbwavedllexport.h"

class QtbValue;

class QTBWAVE_EXPORT QtbFactoryPoint : public QtbStatPoint
{
public:
  QtbFactoryPoint() { _index = -1; }
  QtbFactoryPoint(double x, double y)
    : QtbStatPoint(x, y) { _index = -1; }

  void operator=( const QtbFactoryPoint& o ) { _index = o._index; QtbStatPoint::operator=(o); }
  void operator=( const QtbStatPoint& o ) { QtbStatPoint::operator=(o); }
  void operator=( const QtbStatValue& o ) { QtbStatPoint::operator=(o); }

  int index() const { return _index; }
  void setIndex( int i ) { _index = i; }
private:
  int _index;
};

#endif // QTB_FACTORYPOINT_H
