/***************************************************************************
**
**  Copyright (C) 2002-2009 Marc Wathelet. All rights reserved.
**
**  This file is part of qtbwave.
**
**  This file may be distributed and/or modified under the terms of the
**  GNU General Public License version 2 or 3 as published by the Free
**  Software Foundation and appearing in the file LICENSE.GPL included
**  in the packaging of this file.
**
**  This file is distributed in the hope that it will be useful, but WITHOUT
**  ANY WARRANTY; without even the implied warranty of MERCHANTABILITY or
**  FITNESS FOR A PARTICULAR PURPOSE. See the GNU General Public License for
**  more details.
**
**  See http://www.geopsy.org for more information.
**
**  Created : 2004-04-28
**
***************************************************************************/

#ifndef QTB_LOVE_H
#define QTB_LOVE_H

#include "qtbwavedllexport.h"
#include "qtblayeredmodel.h"

class QTBWAVE_EXPORT QtbLove
{
public:
  QtbLove( const QtbLayeredModel * model ) { _model = model; }

  const QtbLayeredModel * model() const { return _model; }

  void setOmega(double o) { _omega=o; }
  double ellipticity() {return 0;}

  double y(double slowness);
private:
  const QtbLayeredModel * _model;
  double _omega;
};

#endif // QTB_LOVE_H
