/***************************************************************************
**
**  Copyright (C) 2002-2009 Marc Wathelet. All rights reserved.
**
**  This file is part of qtbwave.
**
**  This file may be distributed and/or modified under the terms of the
**  GNU General Public License version 2 or 3 as published by the Free
**  Software Foundation and appearing in the file LICENSE.GPL included
**  in the packaging of this file.
**
**  This file is distributed in the hope that it will be useful, but WITHOUT
**  ANY WARRANTY; without even the implied warranty of MERCHANTABILITY or
**  FITNESS FOR A PARTICULAR PURPOSE. See the GNU General Public License for
**  more details.
**
**  See http://www.geopsy.org for more information.
**
**  Created : 2008-10-17
**
***************************************************************************/

#ifndef QTB_RAYLEIGHFUNCTION_H
#define QTB_RAYLEIGHFUNCTION_H

#include "qtbabstractfunction2.h"
#include "qtbwavedllexport.h"

class QtbLayeredModel;

class QTBWAVE_EXPORT QtbRayleighFunction : public QtbAbstractFunction2
{
public:
  QtbRayleighFunction();
  ~QtbRayleighFunction();

  void setModel( const QtbLayeredModel * m ) { _model = m; }

  virtual double value(double x, double y) const;
private:
  const QtbLayeredModel * _model;
};

#endif // QTB_RAYLEIGHFUNCTION_H
