/***************************************************************************
**
**  Copyright (C) 2002-2009 Marc Wathelet. All rights reserved.
**
**  This file is part of qtbwave.
**
**  This file may be distributed and/or modified under the terms of the
**  GNU General Public License version 2 or 3 as published by the Free
**  Software Foundation and appearing in the file LICENSE.GPL included
**  in the packaging of this file.
**
**  This file is distributed in the hope that it will be useful, but WITHOUT
**  ANY WARRANTY; without even the implied warranty of MERCHANTABILITY or
**  FITNESS FOR A PARTICULAR PURPOSE. See the GNU General Public License for
**  more details.
**
**  See http://www.geopsy.org for more information.
**
**  Created : 2008-10-15
**
***************************************************************************/

#include "qtbshamplification.h"
#include "qtblayeredmodel.h"
#include "qtbnumber.h"
#include "qtbmemorychecker.h"

/*!
  \class QtbShAmplification qtbshamplification.h
  \brief Brief description of class still missing

  Full description of class still missing
*/

/*!
  Kennett method for computation of transfert function
*/
QtbCurve<QtbPoint2D> QtbShAmplification::curve( int fcount, double fmax, float theta )
{
  // This first version use a code in fortran to calculate the transfert function
  float *fr, *u1, *v1, *w3, *al0, *be0, *dens, *th, *qp, *qs, ffmax;
  fr=new float[fcount];
  u1=new float[fcount];
  v1=new float[fcount];
  w3=new float[fcount];
  al0=new float[_model->layerCount()];
  be0=new float[_model->layerCount()];
  dens=new float[_model->layerCount()];
  th=new float[_model->layerCount()];
  qp=new float[_model->layerCount()];
  qs=new float[_model->layerCount()];
  ffmax = fmax;
  // Copy model parameter in appropriate float vectors
  for (int i=0;i<_model->layerCount();i++) {
    if (i<_model->layerCount()-1) th[i]=_model->h(i); else th[i]=1;
    al0[i]=1.0/_model->slowP(i);
    be0[i]=1.0/_model->slowS(i);
    dens[i]=_model->rho(i);
    qp[i]=_model->qp(i);
    qs[i]=_model->qs(i);
  }
  // Compute site respons
  //long nl = _model->layerCount();
  //qtbFortran.kensh(&nl, &theta, &ffmax, &fcountl, al0, be0, dens, th, qp, qs, fr, u1, v1,w3);
  // Get fr and u1 in a list of point_2D
  QtbCurve<QtbPoint2D> c(fcount);
  for (int i=0;i<fcount;i++) {
    QtbPoint2D& p=c[i];
    p.setX( QtbNumber::toDouble( fr[i] ) );
    p.setY( QtbNumber::toDouble( u1[i] ) );
  }
  delete [] fr;
  delete [] u1;
  delete [] v1;
  delete [] w3;
  delete [] al0;
  delete [] be0;
  delete [] dens;
  delete [] th;
  delete [] qp;
  delete [] qs;
  return c;
}
