/***************************************************************************
**
**  Copyright (C) 2002-2009 Marc Wathelet. All rights reserved.
**
**  This file is part of qtbwave.
**
**  This file may be distributed and/or modified under the terms of the
**  GNU General Public License version 2 or 3 as published by the Free
**  Software Foundation and appearing in the file LICENSE.GPL included
**  in the packaging of this file.
**
**  This file is distributed in the hope that it will be useful, but WITHOUT
**  ANY WARRANTY; without even the implied warranty of MERCHANTABILITY or
**  FITNESS FOR A PARTICULAR PURPOSE. See the GNU General Public License for
**  more details.
**
**  See http://www.geopsy.org for more information.
**
**  Created : 2008-10-15
**
***************************************************************************/

#ifndef QTB_SHAMPLIFICATION_H
#define QTB_SHAMPLIFICATION_H

#include "qtbwavedllexport.h"
#include "qtbcurve.h"

class QtbLayeredModel;

class QTBWAVE_EXPORT QtbShAmplification
{
public:
  QtbShAmplification( const QtbLayeredModel * model ) { _model = model; }

  QtbCurve<QtbPoint2D> curve( int fcount, double fmax, float theta );
private:
  const QtbLayeredModel * _model;
};

#endif // QTB_SHAMPLIFICATION_H
