/***************************************************************************
**
**  Copyright (C) 2002-2009 Marc Wathelet. All rights reserved.
**
**  This file is part of qtbwave.
**
**  This file may be distributed and/or modified under the terms of the
**  GNU General Public License version 2 or 3 as published by the Free
**  Software Foundation and appearing in the file LICENSE.GPL included
**  in the packaging of this file.
**
**  This file is distributed in the hope that it will be useful, but WITHOUT
**  ANY WARRANTY; without even the implied warranty of MERCHANTABILITY or
**  FITNESS FOR A PARTICULAR PURPOSE. See the GNU General Public License for
**  more details.
**
**  See http://www.geopsy.org for more information.
**
**  Created : 2009-02-03
**
***************************************************************************/

#ifndef QTB_THEORETICALLINEARFK_H
#define QTB_THEORETICALLINEARFK_H

#include "qtbtheoreticalfk.h"
#include "qtbangle.h"
#include "qtbwavedllexport.h"

class QTBWAVE_EXPORT QtbTheoreticalLinearFK : public QtbTheoreticalFK
{
public:
  QtbTheoreticalLinearFK(QVector<QtbPoint> * stations) : QtbTheoreticalFK(stations) {}

  void setRadians( double a ) { _angle.setRadians(a); }
  void setAzimuth( double a ) { _angle.setDegreeAzimuth(a); }
  void setAngle( const QtbAngle& a ) { _angle = a; }
  const QtbAngle& angle() const { return _angle; }

  inline virtual double value(double k);
  inline double y(double k) { return value(k)-0.5; }
private:
  QtbAngle _angle;
};

inline double QtbTheoreticalLinearFK::value(double k)
{
  QTB_TRACE;
  return QtbTheoreticalFK::value( k*_angle.cos(), k*_angle.sin() );
}

#endif // QTB_THEORETICALLINEARFK_H
