/***************************************************************************
**
**  Copyright (C) 2002-2009 Marc Wathelet. All rights reserved.
**
**  This file is part of qtbwave.
**
**  This file may be distributed and/or modified under the terms of the
**  GNU General Public License version 2 or 3 as published by the Free
**  Software Foundation and appearing in the file LICENSE.GPL included
**  in the packaging of this file.
**
**  This file is distributed in the hope that it will be useful, but WITHOUT
**  ANY WARRANTY; without even the implied warranty of MERCHANTABILITY or
**  FITNESS FOR A PARTICULAR PURPOSE. See the GNU General Public License for
**  more details.
**
**  See http://www.geopsy.org for more information.
**
**  Created : 2008-08-06
**
***************************************************************************/

#ifndef QTB_TILTNODE_H
#define QTB_TILTNODE_H

#include "qtbtiltlayeredmodel.h"
#include "qtbwavedllexport.h"

class QtbTiltPath;

class QTBWAVE_EXPORT QtbTiltNode
{
public:
  QtbTiltNode();
  ~QtbTiltNode();

  void init(double x0, const QtbTiltLayeredModel& model);
  double x() const;
  const QtbTiltPath * left() const { return _leftPaths; }
  const QtbTiltPath * right() const { return _rightPaths; }
private:
  void initPaths( QtbTiltLayeredModel::Direction dir, QtbTiltPath *& paths,
                  double x0, const QtbTiltLayeredModel& model );

  QtbTiltPath * _leftPaths;
  QtbTiltPath * _rightPaths;
};

#endif // QTB_TILTNODE_H
